ecommerce/urls.py
from django.contrib import admin
from django.urls import path, include
from shop import views
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('choice/', admin.site.urls),
    path('', include('shop.urls')),
]

if settings.DEBUG:
    import debug_toolbar
    urlpatterns = [
        path('__debub__/', include(debug_toolbar.urls)),
    ] + urlpatterns
    urlpatterns += static(settings.STATIC_URL, document_root = settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root = settings.MEDIA_ROOT)

shop/urls.py
from django.urls import path
from . import views

app_name = 'shop'

urlpatterns = [
    path('', views.index, name='index'),
    path('produit/<int:product_id>/', views.detail, name='detail'),
    path('category/<int:category_id>/', views.categorydetail, name='categorydetail'),
    path('search/', views.search, name='search'),
    path('about.html/', views.about, name='about'),
    path('service.html/', views.service, name='service'),
    path('contact.html/', views.contact, name='contact'),
]

contacts/models.py
import datetime
from django.db import models

# Create your models here.
class Contact(models.Model):
    contact_name = models.CharField(max_length=100)
    contact_email = models.EmailField()
    contact_num = models.CharField('contact number', max_length=25)
    contact_body = models.TextField()
    contact_pub_date = models.DateTimeField('publication date', auto_now_add=True)
    contact_readed = models.BooleanField('read statut', default=False)
    contact_answered = models.BooleanField('answer statut', default=False)

    def __str__(self):
        return self.contact_name

shop/models.py
import datetime
from django.db import models
from django.utils import timezone
from ckeditor.fields import RichTextField

# Create your models here.
class Category(models.Model):
    category_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField('publication date', auto_now_add=True)

    def __str__(self):
        return self.category_text

    def was_published_recently(self):
        return self.pub_date >= timezone.now() - datetime.timedelta(days=1)

class Product(models.Model):
    category = models.ForeignKey(Category, on_delete=models.CASCADE)
    product_name = models.CharField(max_length=200)
    product_price = models.IntegerField('product price', default=0)
    product_description = RichTextField(blank=True, null=True)
    product_image = models.FileField(upload_to='products')
    product_pub_date = models.DateTimeField('publication date', auto_now_add=True)
    product_mod_date = models.DateTimeField('modification date', auto_now=True)
    product_disponibility = models.BooleanField(default=False)
    product_views = models.IntegerField(default=0)
    product_buy = models.IntegerField('buy link click', default=0)

    def __str__(self):
        return self.product_name

    def was_published_recently(self):
        return self.product_pub_date >= timezone.now() - datetime.timedelta(days=1)

    def was_modificated_recently(self):
        return self.product_mod_date >= timezone.now() - datetime.timedelta(days=1)

class Publicity(models.Model):
    publicity_name = models.CharField(max_length=200)
    publicity_image = models.FileField(upload_to='publicities')
    publicity_url = models.URLField('publicity website url')
    publicity_pub_date = models.DateTimeField('publication date', auto_now_add=True)
    publicity_mod_date = models.DateTimeField('modification date', auto_now=True)
    publicity_disponibility = models.BooleanField('disponibility', default=False)

    def __str__(self):
        return self.publicity_name

    def was_published_recently(self):
        return self.publicity_pub_date >= timezone.now() - datetime.timedelta(days=1)

    def was_modificated_recently(self):
        return self.publicity_mod_date >= timezone.now() - datetime.timedelta(days=1)
    

contacts/views.py
from django.shortcuts import render

# Create your views here.

shop/views.py
import datetime
from datetime import date
from django.core.exceptions import ObjectDoesNotExist
from django.utils import timezone
from django.http import HttpResponse
from django.shortcuts import render, get_object_or_404, redirect, get_list_or_404, redirect, reverse
from django.template import loader

from .models import Product, Category, Publicity

from history.models import  SiteView, SiteViewsPerDay
from about_page.models import About
from clicks.models import ClickOnBuyLink, ClickOnBuyLinkPerDay
from contacts.models import Contact
from contacts.form import ContactForm

# Create your views here.

def views():
    
    try:
        views = SiteView.objects.get()
        views.view_count = views.view_count + 1
        views.save()
    except ObjectDoesNotExist:
        views = SiteView(view_name='All site views', view_count=1, first_view=date.today(), last_view=timezone.now())
        views.save()

    try :
        view_day = SiteViewsPerDay.objects.filter(view_day=date.today()).get()
        view_day.views = view_day.views + 1
        view_day.save()
    except ObjectDoesNotExist:
        view_day = SiteViewsPerDay(first_view=timezone.now(), last_view=timezone.now(), views=1, view_day=date.today())
        view_day.save()
        

def index(request):
    latest_product_list = Product.objects.filter(product_disponibility=True).order_by('-product_pub_date')
    category_list = Category.objects.order_by('-id')
    publicity_list = Publicity.objects.filter(publicity_disponibility=True)
    context = {
        'latest_product_list': latest_product_list,
        'category_list': category_list,
        'publicity_list': publicity_list,
    }

    views()

    return render(request, 'shop/index.html', context)

def categorydetail(request, category_id):
    category_list = Category.objects.order_by('-id')
    publicity_list = Publicity.objects.filter(publicity_disponibility=True)
    products = get_list_or_404(Product.objects.filter(product_disponibility=True).order_by('-product_pub_date'), category=category_id)
    
    context = {
        'category_list': category_list,
        'publicity_list': publicity_list,
        'products' : products,
    }

    views()
    
    return render(request, 'shop/category.html', context)

def detail(request, product_id):
    product = get_object_or_404(Product, pk=product_id)

    if request.method == 'POST':
        product.product_buy = product.product_buy + 1
        product.save()

        try:
            click = ClickOnBuyLink.objects.get()
            click.click = click.click +1
            click.save()
        except ObjectDoesNotExist:
            click = ClickOnBuyLink(click_name='Click on buy link', click=1, first_click=timezone.now(), last_click=timezone.now())
            click.save()

        try :
            click_day = ClickOnBuyLinkPerDay.objects.filter(click_day=date.today()).get()
            click_day.click = click_day.click + 1
            click_day.save()
        except ObjectDoesNotExist:
            click_day = ClickOnBuyLinkPerDay(click=1, first_click=timezone.now(), last_click=timezone.now(), click_day=date.today())
            click_day.save()

        urlObject = request._current_scheme_host + request.path
        
        url = 'https://wa.me/22892108027?text=J%27ai%20vu%20votre%20produit%20sur%20votre%20site%20web%20et%20je%20suis%20int%C3%A9rrress%C3%A9.%20Voici%20son%20lien%20%3A%0A' + urlObject
        return redirect(url)


    product.product_views = product.product_views + 1
    product.save()

    category_list = Category.objects.order_by('-id')
    publicity_list = Publicity.objects.filter(publicity_disponibility=True)
    context = {
        'product': product,
        'category_list': category_list,
        'publicity_list': publicity_list,
    }

    views()
    
    return render(request, 'shop/detail.html', context)

def search(request):
    response = "You're looking at the results of product."
    category_list = Category.objects.order_by('-id')
    publicity_list = Publicity.objects.filter(publicity_disponibility=True)

    views()
    
    if request.method == "POST":
        searched = request.POST['searched']
        products = Product.objects.filter(product_name__icontains=searched)
        products = Product.objects.filter(product_description__icontains=searched)
        products = Product.objects.filter(category__category_text__icontains=searched)

        context = {
            'searched' : searched,
            'category_list': category_list,
            'publicity_list': publicity_list,
            'products': products,
        }

        return render(request, 'shop/search.html', context)
    else:
        context = {
            'category_list': category_list,
            'publicity_list': publicity_list,
        }
        return render(request, 'shop/search.html', context)


def about(request):
    about_list = About.objects.order_by('id')
    category_list = Category.objects.order_by('-id')
    publicity_list = Publicity.objects.filter(publicity_disponibility=True)
    context = {
        'about_list': about_list,
        'category_list': category_list,
        'publicity_list': publicity_list,
    }

    views()
    
    return render(request, 'shop/about.html', context)


def service(request):
    service = 'You\'re looking at services'
    category_list = Category.objects.order_by('-id')
    publicity_list = Publicity.objects.filter(publicity_disponibility=True)

    context = {
        'service': service,
        'category_list': category_list,
        'publicity_list': publicity_list,
    }

    views()
    
    return render(request, 'shop/service.html', context)

    
def contact(request):
    category_list = Category.objects.order_by('-id')
    publicity_list = Publicity.objects.filter(publicity_disponibility=True)
    if request.method == "POST":
        form = ContactForm(request.POST)
        if form.is_valid():
            form.save()
            return redirect("/")
    else:
        form = ContactForm()

    context = {
        "form": form,
        'category_list': category_list,
        'publicity_list': publicity_list,
    }

    views()
    
    return render(request, 'shop/contact.html', context)

shop/templates/shop/about.html
{% extends 'shop/base.html' %}

{% block content %}
            <div class="col-lg-9">

                <div class="card mt-4">
                  <div class="card-body">
                    {% if about_list %}
                      {% for about in about_list %}
                    <p class="card-text">{{ about.about_text | safe }}</p>
                      {% endfor %}
                    {% endif %}
                  </div>
                </div>
                <!-- /.card -->
                <br>
              </div>
              <!-- /.col-lg-9 -->
{% endblock %}

shop/templates/shop/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">

<head>

  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <meta name="description" content="">
  <meta name="author" content="">

  <title>Basic E-commerce Web Site</title>

  <!-- Bootstrap core CSS -->
  <link href="{% static 'shop/vendor/bootstrap/css/bootstrap.min.css' %}" rel="stylesheet">

  <!-- Custom styles for this template -->
  <link href="{% static 'shop/css/shop-homepage.css' %}" rel="stylesheet">

  <link rel="shortcut icon" href="{% static 'shop/vendor/img/favicon.png' %}">

  <link rel="stylesheet" href="{% static 'shop/fontawesome/css/all.min.css' %}">

</head>

<body>

  {% include 'shop/nav.html' %}

  <!-- Page Content -->
  <div class="container">

    <div class="row">

      <div class="col-lg-3">

        <h1 class="my-4">Liste des catégories</h1>
        <div class="list-group">
          {% include 'shop/side_category.html' %}
        </div>
        <br /><br />

      </div>
      <!-- /.col-lg-3 -->

      <div class="col-lg-9">

        {% include 'shop/publicity.html' %}

        <div class="row">

            {% block content %}{% endblock %}

        </div>
        <!-- /.row -->

      </div>
      <!-- /.col-lg-9 -->

    </div>
    <!-- /.row -->

  </div>
  <!-- /.container -->

  <!-- Footer -->
  <footer class="py-5 bg-dark">
    <div class="container">
      <p class="m-0 text-center text-white">Copyright <a href="/choice" class="href" target="_blank">&copy;</a> Your Website 2020</p>
    </div>
    <!-- /.container -->
  </footer>

  <!-- Bootstrap core JavaScript -->
  <script src="{% static 'shop/vendor/jquery/jquery.min.js' %}"></script>
  <script src="{% static 'shop/vendor/bootstrap/js/bootstrap.bundle.min.js' %}"></script>

</body>

</html>

shop/templates/shop/category.html
{% extends 'shop/base.html' %}

{% block content %}
    {% if products %}
        {% for product in products %}
            <div class="col-lg-4 col-md-6 mb-4">
                <div class="card h-100">
                    <a href="{% url 'shop:detail' product.id %}"><img class="card-img-top" src="/static/shop/vendor/img/{{ product.product_image }}" alt=""></a>
                    <div class="card-body">
                        <h4 class="card-title">
                        <a href="{% url 'shop:detail' product.id %}">{{ product.product_name }}</a>
                        </h4>
                        <h5>{{ product.product_price }}</h5>
                        <p class="card-text">{{ product.product_description }}</p>
                    </div>
                    <div class="card-footer">
                        <small class="text-muted">&#9733; &#9733; &#9733; &#9733; &#9734;</small>
                        <a href="{% url 'shop:categorydetail' product.category.id %}">{{ product.category }}</a>
                    </div>
                </div>
            </div>
        {% endfor %}
    {% else %}
        <p class="card-text">No category are available.</p>
    {% endif %}
{% endblock %}

shop/templates/shop/contact.html
{% extends 'shop/base.html' %}

{% block content %}
    <form action="{% url 'shop:contact' %}" method="post">
        <table>
            {{ form }}
        </table>
        {% csrf_token %}
        <button class="btn btn-success" type="submit">Contact</button>
    </form>
{% endblock %}

shop/templates/shop/detail.html
{% extends 'shop/base.html' %}

{% block content %}
            <div class="col-lg-9">

                <div class="card mt-4">
                  <img class="card-img-top" src="/static/shop/vendor/img/{{ product.product_image }}" alt="">
                  <div class="card-body">
                    <h3 class="card-title">{{ product.product_name }}</h3>
                    <h4>{{ product.product_price }}</h4>
                    <p class="card-text">{{ product.product_description | safe }}</p>
                    <span class="text-warning">&#9733; &#9733; &#9733; &#9733; &#9734;</span>
                    4.0 stars <a href="{% url 'shop:categorydetail' product.category.id %}">{{ product.category }}</a>
                  </div>
                    <div class="card-body">
                        <form method="post">
                          {% csrf_token %}
                          <button class="btn btn-success" type="submit">Acheter</button>
                      </form>
                    </div>
                </div>
                <!-- /.card -->
                <br>
            </div>
              <!-- /.col-lg-9 -->
{% endblock %}

shop/templates/shop/index.html
{% extends 'shop/base.html' %}

{% block content %}
    {% if latest_product_list %}
        {% for product in latest_product_list %}
            <div class="col-lg-4 col-md-6 mb-4">
                <div class="card h-100">
                    <a href="{% url 'shop:detail' product.id %}"><img class="card-img-top" src="/static/shop/vendor/img/{{ product.product_image }}" alt=""></a>
                    <div class="card-body">
                        <h4 class="card-title">
                        <a href="{% url 'shop:detail' product.id %}">{{ product.product_name }}</a>
                        </h4>
                        <h5>{{ product.product_price }}</h5>
                        <p class="card-text">{{ product.product_description | safe }}</p>
                    </div>
                    <div class="card-footer">
                        <small class="text-muted">&#9733; &#9733; &#9733; &#9733; &#9734;</small>
                        <a href="{% url 'shop:categorydetail' product.category.id %}">{{ product.category }}</a>
                    </div>
                </div>
            </div>
        {% endfor %}
    {% else %}
        <p class="card-text">No products are available.</p>
    {% endif %}
{% endblock %}

shop/templates/shop/nav.html
{% url 'shop:index' as home %}
{% url 'shop:about' as about %}
{% url 'shop:service' as service %}
{% url 'shop:contact' as contact %}


<!-- Navigation -->
<nav class="navbar navbar-expand-lg navbar-dark bg-dark fixed-top">
    <div class="container">
      <a class="navbar-brand" href="{% url 'shop:index' %}">Basic E-commerce Web Site</a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarResponsive" aria-controls="navbarResponsive" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarResponsive">
        <ul class="navbar-nav ml-auto">
          <li class="nav-item{% if request.path == home %} active{% else %}{% endif %}">
            <a class="nav-link" href="{% url 'shop:index' %}">Home
              <span class="sr-only">(current)</span>
            </a>
          </li>
          <li class="nav-item{% if request.path == about %} active{% else %}{% endif %}">
            <a class="nav-link" href="{% url 'shop:about' %}">About</a>
          </li>
          <li class="nav-item{% if request.path == service %} active{% else %}{% endif %}">
            <a class="nav-link" href="{% url 'shop:service' %}">Services</a>
          </li>
          <li class="nav-item{% if request.path == contact %} active{% else %}{% endif %}">
            <a class="nav-link" href="{% url 'shop:contact' %}">Contact</a>
          </li>
        </ul> &nbsp
		<form class="form-inline mt-2 mt-md-0" action="{% url 'shop:search' %}" method="post">
      {% csrf_token %}
			<input class="form-control mr-sm-2" type="text" placeholder="Search Products" aria-label="Search" name="searched">
			<button class="btn btn-outline-secondary my-2 my-sm-0" type="submit">Search</button>
		</form>
      </div>
    </div>
  </nav>

shop/templates/shop/publicity.html
        <div id="carouselExampleIndicators" class="carousel slide my-4" data-ride="carousel">
            <ol class="carousel-indicators">
                {% for publicity in publicity_list %}
                <li data-target="#carouselExampleIndicators" data-slide-to="{{ forloop.counter0 }}" class="{% if forloop.counter0 == 0 %}active{% else %}{% endif %}"></li>
                {% endfor %}
            </ol>
            <div class="carousel-inner" role="listbox">
                {% for publicity in publicity_list %}
                <div class="carousel-item{% if forloop.counter0 == 0 %} active{% else %}{% endif %}">
                    <a href="{{ publicity.publicity_url }}" target="_blank"><img class="d-block img-fluid" src="/static/shop/vendor/img/{{ publicity.publicity_image }}" alt="First slide"></a>
                </div>
                {% endfor %}
            </div>
            <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
            <span class="sr-only">Previous</span>
            </a>
            <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
            <span class="carousel-control-next-icon" aria-hidden="true"></span>
            <span class="sr-only">Next</span>
            </a>
        </div>

shop/templates/shop/search.html
{% extends 'shop/base.html' %}

{% block content %}
    {% if searched %}
        {% if products %}
            {% for product in products %}
                <div class="col-lg-4 col-md-6 mb-4">
                    <div class="card h-100">
                        <a href="{% url 'shop:detail' product.id %}"><img class="card-img-top" src="/static/shop/vendor/img/{{ product.product_image }}" alt=""></a>
                        <div class="card-body">
                            <h4 class="card-title">
                            <a href="{% url 'shop:detail' product.id %}">{{ product.product_name }}</a>
                            </h4>
                            <h5>{{ product.product_price }}</h5>
                            <p class="card-text">{{ product.product_description }}</p>
                        </div>
                        <div class="card-footer">
                            <small class="text-muted">&#9733; &#9733; &#9733; &#9733; &#9734;</small>
                            <a href="{% url 'shop:categorydetail' product.category.id %}">{{ product.category }}</a>
                        </div>
                    </div>
                </div>
            {% endfor %}
        {% else %}
            <p class="card-text">No products are available.</p>
        {% endif%}
    {% else %}
    <p class="card-text">No word enter for search. Please enter a word. Thanks...</p>
    {% endif %}
{% endblock %}

shop/templates/shop/service.html
{% extends 'shop/base.html' %}

{% block content %}
    {{ service }}
{% endblock %}

shop/templates/shop/side_category.html
{% url 'shop:index' as home %}
{% url 'shop:categorydetail' as categorydetail %}


    {% if category_list %}
            <a href="{% url 'shop:index' %}" class="list-group-item{% if request.path == home %} active{% else %}{% endif %}">Tous les produits</a>
        {% for category in category_list %}
            <a href="{% url 'shop:categorydetail' category.id %}" class="list-group-item{% if category.id == product.category.id %} active{% else %}{% endif %}">{{ category.category_text }}</a>
        {% endfor %}
    {% endif%}